use precision
implicit none
integer,parameter :: NR=20
integer :: i,n,ic,iswitch
real(long) cmax,d
real(long),allocatable,dimension(:,:)  :: a,ap
real(long),allocatable,dimension(:)  :: b
integer,allocatable,dimension(:)  :: indx
write(*,*) ' You have 4 choices '
write(*,*) ' 1) fill the matrix with random values (default)'
write(*,*) ' 2) the hilbert matrix '
write(*,*) ' 3) a user-defined matrix: edit user.f90 first'
write(*,*) ' 4) read a matrix and a RHS from mat.dat'
read(*,*) ic
select case (ic)
  case (1,5:)
    write(*,*) 'how big should the matrix be?'
    read(*,*) n
    allocate(a(n,n))
    allocate(ap(n,n))
    allocate(indx(n))
    write(*,*) 'do you want to use ludcmp/lubksb (0) or lured/reslv (1) '
    read(*,*) iswitch
    call rand_mat(a,n,n)
    ap=a
    call calc_inv(a,ap,n,cmax,indx,iswitch)
    write(*,*) 'The maximum error is ',cmax
  case (2)
    write(*,*) 'how big should the matrix be?'
    read(*,*) n
    allocate(a(n,n))
    allocate(ap(n,n))
    allocate(indx(n))
    write(*,*) 'do you want to use ludcmp/lubksb (0) or lured/reslv (1) '
    read(*,*) iswitch
    call hilbert(a,n,n)
    ap=a
    call calc_inv(a,ap,n,cmax,indx,iswitch)
    write(*,*) 'The maximum error is ',cmax
  case (3)
    write(*,*) 'how big should the matrix be?'
    read(*,*) n
    allocate(a(n,n))
    allocate(ap(n,n))
    allocate(indx(n))
    write(*,*) 'do you want to use ludcmp/lubksb (0) or lured/reslv (1) '
    read(*,*) iswitch
    call user(a,n,n)
    ap=a
    call calc_inv(a,ap,n,cmax,indx,iswitch)
    write(*,*) 'The maximum error is ',cmax
  case (4)
    allocate(a(NR,NR))
    allocate(b(NR))
    allocate(ap(NR,NR))
    allocate(indx(NR))
    call read_mat(a,b,n,NR)
    write(*,*) 'do you want to use ludcmp/lubksb (0) or lured/reslv (1) '
    read(*,*) iswitch
    if(iswitch.eq.0) then
      call ludcmp(a,n,NR,indx,d)
      call lubksb(a,n,NR,indx,b)
    else
      call lured(a,n,NR)
      call reslv(a,b,n,NR)
    endif
    write(*,*) 'The solutions are'
    do i=1,n
      write(*,*) b(i)
    enddo
    deallocate(b)
end select
deallocate(a)
deallocate(ap)
deallocate(indx)
stop
end
